diff --git a/src/modules/Extensions/YouTube.cpp b/src/modules/Extensions/YouTube.cpp
index 4d7b794f..d168f9bb 100644
--- a/src/modules/Extensions/YouTube.cpp
+++ b/src/modules/Extensions/YouTube.cpp
@@ -21,19 +21,14 @@
 #include <YouTubeDL.hpp>
 #include <LineEdit.hpp>
 
-#include <QLoggingCategory>
 #include <QStringListModel>
 #include <QDesktopServices>
-#include <QJsonParseError>
 #include <QTextDocument>
-#include <QJsonDocument>
 #include <QProgressBar>
 #include <QApplication>
-#include <QJsonObject>
 #include <QHeaderView>
 #include <QGridLayout>
 #include <QToolButton>
-#include <QJsonArray>
 #include <QCompleter>
 #include <QClipboard>
 #include <QMimeData>
@@ -41,8 +36,12 @@
 #include <QAction>
 #include <QMenu>
 #include <QUrl>
+#include <QSignalMapper>
+#include <QDebug>
 
-Q_LOGGING_CATEGORY(youtube, "Extensions/YouTube")
+#include <QJsonParseError.h>
+#include <QJsonObject.h>
+#include <QJsonArray.h>
 
 #define YOUTUBE_URL "https://www.youtube.com"
 
@@ -53,7 +52,7 @@ static inline QString toPercentEncoding(const QString &txt)
 
 static inline QString getYtUrl(const QString &title, const int page, const int sortByIdx)
 {
-    static constexpr const char *sortBy[4] {
+    static const char *sortBy[4] {
         "",             // Relevance ("&sp=CAA%253D")
         "&sp=CAI%253D", // Upload date
         "&sp=CAM%253D", // View count
@@ -89,8 +88,8 @@ ResultsYoutube::ResultsYoutube()
     headerItem()->setText(2, tr("User"));
 
     header()->setStretchLastSection(false);
-    header()->setSectionResizeMode(0, QHeaderView::Stretch);
-    header()->setSectionResizeMode(1, QHeaderView::ResizeToContents);
+    header()->setResizeMode(0, QHeaderView::Stretch);
+    header()->setResizeMode(1, QHeaderView::ResizeToContents);
 
     connect(this, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)), this, SLOT(playEntry(QTreeWidgetItem *)));
     connect(this, SIGNAL(customContextMenuRequested(const QPoint &)), this, SLOT(contextMenu(const QPoint &)));
@@ -126,6 +125,24 @@ void ResultsYoutube::playEntry(QTreeWidgetItem *tWI)
     playOrEnqueue("open", tWI);
 }
 
+void ResultsYoutube::playCurrentItem()
+{
+    QTreeWidgetItem *tWI = currentItem();
+    if (!tWI)
+        return;
+
+    playOrEnqueue("open", tWI, currentParam);
+}
+
+void ResultsYoutube::enqueueCurrentItem()
+{
+    QTreeWidgetItem *tWI = currentItem();
+    if (!tWI)
+        return;
+
+    playOrEnqueue("enqueue", tWI, currentParam);
+}
+
 void ResultsYoutube::openPage()
 {
     QTreeWidgetItem *tWI = currentItem();
@@ -155,17 +172,19 @@ void ResultsYoutube::contextMenu(const QPoint &point)
 
     for (int i = 0; i < 2; ++i)
     {
-        menu->addSection(i == 0 ? tr("Audio and video") : tr("Audio only"));
+        QAction *section = new QAction(i == 0 ? tr("Audio and video") : tr("Audio only"), menu);
+        section->setEnabled(false); // Make it non-interactive
+        menu->addAction(section);
 
         if (!tWI->isDisabled())
         {
-            const auto param = i == 0 ? QString() : QString("audio");
-            menu->addAction(tr("Play"), this, [=] {
-                playOrEnqueue("open", currentItem(), param);
-            });
-            menu->addAction(tr("Enqueue"), this, [=] {
-                playOrEnqueue("enqueue", currentItem(), param);
-            });
+            currentParam = (i == 0 ? QString() : QString("audio"));
+            QAction *playAction = menu->addAction(tr("Play"));
+            QAction *enqueueAction = menu->addAction(tr("Enqueue"));
+
+            connect(playAction, SIGNAL(triggered()), this, SLOT(playCurrentItem()));
+            connect(enqueueAction, SIGNAL(triggered()), this, SLOT(enqueueCurrentItem()));
+
             menu->addSeparator();
         }
 
@@ -239,6 +258,18 @@ const QStringList YouTube::getQualityPresets()
     };
 }
 
+void YouTube::onQualityPresetChanged(const QString &preset) {
+    sets().set("YouTube/QualityPreset", preset);
+}
+
+void YouTube::onQualityToggled() {
+    QAction *act = qobject_cast<QAction *>(sender());
+    if (act && act->isChecked()) {
+        int qualityIdx = m_qualityGroup->actions().indexOf(act);
+        setItags(qualityIdx);
+    }
+}
+
 YouTube::YouTube(Module &module) :
     completer(new QCompleter(new QStringListModel(this), this)),
     currPage(1),
@@ -270,9 +301,8 @@ YouTube::YouTube(Module &module) :
     searchB->setAutoRaise(true);
 
     QToolButton *showSettingsB = new QToolButton;
-    connect(showSettingsB, &QToolButton::clicked, this, [] {
-        emit QMPlay2Core.showSettings("Extensions");
-    });
+    connect(showSettingsB, SIGNAL(clicked()), this, SLOT(onShowSettingsClicked()));
+
     showSettingsB->setIcon(QMPlay2Core.getIconFromTheme("configure"));
     showSettingsB->setToolTip(tr("Settings"));
     showSettingsB->setAutoRaise(true);
@@ -283,20 +313,23 @@ YouTube::YouTube(Module &module) :
 
     QMenu *qualityMenu = new QMenu(this);
     int qualityIdx = 0;
-    for (QAction *act : m_qualityGroup->actions())
-    {
-        connect(act, &QAction::triggered, this, [=] {
-            sets().set("YouTube/QualityPreset", act->text());
-        });
-        connect(act, &QAction::toggled, this, [=](bool checked) {
-            if (checked)
-                setItags(qualityIdx);
-        });
+    QSignalMapper *qualitySignalMapper = new QSignalMapper(this);
+
+    for (int i = 0; i < m_qualityGroup->actions().size(); ++i) {
+        QAction *act = m_qualityGroup->actions().at(i);
+
+        qualitySignalMapper->setMapping(act, act->text());
+        connect(act, SIGNAL(triggered()), qualitySignalMapper, SLOT(map()));
+        connect(act, SIGNAL(toggled(bool)), this, SLOT(onQualityToggled()));
+
         act->setCheckable(true);
         qualityMenu->addAction(act);
         ++qualityIdx;
     }
-    qualityMenu->insertSeparator(qualityMenu->actions().at(5));
+    connect(qualitySignalMapper, SIGNAL(mapped(QString)), this, SLOT(onQualityPresetChanged(QString)));
+    if (qualityMenu->actions().size() > 5) {
+        qualityMenu->insertSeparator(qualityMenu->actions().at(5));
+    }
 
     QToolButton *qualityB = new QToolButton;
     qualityB->setPopupMode(QToolButton::InstantPopup);
@@ -312,21 +345,18 @@ YouTube::YouTube(Module &module) :
     m_sortByGroup->addAction(tr("Rating"));
 
     QMenu *sortByMenu = new QMenu(this);
-    int sortByIdx = 0;
-    for (QAction *act : m_sortByGroup->actions())
-    {
-        connect(act, &QAction::triggered, this, [=] {
-            if (m_sortByIdx != sortByIdx)
-            {
-                m_sortByIdx = sortByIdx;
-                sets().set("YouTube/SortBy", m_sortByIdx);
-                search();
-            }
-        });
+    QSignalMapper *sortBySignalMapper = new QSignalMapper(this);
+
+    for (int i = 0; i < m_sortByGroup->actions().size(); ++i) {
+        QAction *act = m_sortByGroup->actions().at(i);
+
+        sortBySignalMapper->setMapping(act, i);
+        connect(act, SIGNAL(triggered()), sortBySignalMapper, SLOT(map()));
+
         act->setCheckable(true);
         sortByMenu->addAction(act);
-        ++sortByIdx;
     }
+    connect(sortBySignalMapper, SIGNAL(mapped(int)), this, SLOT(onSortByChanged(int)));
 
     QToolButton *sortByB = new QToolButton;
     sortByB->setPopupMode(QToolButton::InstantPopup);
@@ -371,6 +401,23 @@ YouTube::~YouTube()
 
 bool YouTube::set()
 {
+    const auto preferredCodec = sets().getString("YouTube/PreferredCodec");
+    const auto oldPpreferredCodec = m_preferredCodec;
+    const auto oldAllowVp9Hdr = m_allowVp9Hdr;
+
+    if (preferredCodec == "H.264")
+        m_preferredCodec = PreferredCodec::H264;
+    else if (preferredCodec == "AV1")
+        m_preferredCodec = PreferredCodec::AV1;
+    else
+        m_preferredCodec = PreferredCodec::VP9;
+
+    m_allowVp9Hdr = sets().getBool("YouTube/AllowVp9HDR");
+
+    auto forceToggledSignal = [&] {
+        return (oldPpreferredCodec != m_preferredCodec || oldAllowVp9Hdr != m_allowVp9Hdr);
+    };
+
     const auto qualityActions = m_qualityGroup->actions();
     const auto qualityText = sets().getString("YouTube/QualityPreset");
     bool qualityActionChecked = false;
@@ -380,6 +427,8 @@ bool YouTube::set()
         {
             if (qualityAction->text() == qualityText)
             {
+                if (forceToggledSignal() && qualityAction->isChecked())
+                    qualityAction->setChecked(false); // Force "toggled" signal
                 qualityAction->setChecked(true);
                 qualityActionChecked = true;
                 break;
@@ -387,7 +436,11 @@ bool YouTube::set()
         }
     }
     if (!qualityActionChecked)
+    {
+        if (forceToggledSignal() && qualityActions[3]->isChecked())
+            qualityActions[3]->setChecked(false); // Force "toggled" signal
         qualityActions[3]->setChecked(true);
+    }
 
     resultsW->setColumnCount(sets().getBool("YouTube/ShowUserName") ? 3 : 2);
     m_allowSubtitles = sets().getBool("YouTube/Subtitles");
@@ -597,118 +650,191 @@ void YouTube::searchMenu()
 
 void YouTube::setItags(int qualityIdx)
 {
-#if 0 // Itag info (incomplete)
-    Video + Audio:
-    43 = 360p WebM (VP8 + Vorbis 128kbps)
-    36 = 180p MP4 (MPEG4 + AAC 32kbps)
-    22 = 720p MP4 (H.264 + AAC 192kbps)
-    18 = 360p MP4 (H.264 + AAC 96kbps)
-     5 = 240p FLV (FLV + MP3 64kbps)
-
-    Video only:
-    247 = Video  720p (VP9)
-    248 = Video 1080p (VP9)
-    271 = Video 1440p (VP9)
-    313 = Video 2160p (VP9)
-    272 = Video 4320p/2160p (VP9)
-
-    302 = Video  720p 60fps (VP9)
-    303 = Video 1080p 60fps (VP9)
-    308 = Video 1440p 60fps (VP9)
-    315 = Video 2160p 60fps (VP9)
-
-    298 = Video  720p 60fps (H.264)
-    299 = Video 1080p 60fps (H.264)
-
-    135 = Video  480p (H.264)
-    136 = Video  720p (H.264)
-    137 = Video 1080p (H.264)
-    264 = Video 1440p (H.264)
-    266 = Video 2160p (H.264)
-
-    170 = Video  480p (VP8)
-    168 = Video  720p (VP8)
-    170 = Video 1080p (VP8)
-
-    Audio only:
-    139 = Audio (AAC 48kbps)
-    140 = Audio (AAC 128kbps)
-    141 = Audio (AAC 256kbps) //?
-
-    171 = Audio (Vorbis 128kbps)
-    172 = Audio (Vorbis 256kbps) //?
-
-    249 = Audio (Opus 50kbps)
-    250 = Audio (Opus 70kbps)
-    251 = Audio (Opus 160kbps)
-#endif
+    // Itag info: https://gist.github.com/AgentOak/34d47c65b1d28829bb17c24c04a0096f
+    enum
+    {
+        // Video
+        H264_144p = 160,
+        H264_240p = 133,
+        H264_360p = 134,
+        H264_480p = 135,
+        H264_720p = 136,
+        H264_1080p = 137,
+        H264_1440p = 264,
+        H264_2160p = 266,
+
+        H264_720p60 = 298,
+        H264_1080p60 = 299,
+        H264_1440p60 = 304,
+        H264_2160p60 = 305,
+
+        VP9_144p = 278,
+        VP9_240p = 242,
+        VP9_360p = 243,
+        VP9_480p = 244,
+        VP9_720p = 247,
+        VP9_1080p = 248,
+        VP9_1440p = 271,
+        VP9_2160p = 313,
+
+        VP9_720p60 = 302,
+        VP9_1080p60 = 303,
+        VP9_1440p60 = 308,
+        VP9_2160p60 = 315,
+        VP9_4320p60 = 272,
+
+        VP9_720p60_HDR = 334,
+        VP9_1080p60_HDR = 335,
+        VP9_1440p60_HDR = 336,
+        VP9_2160p60_HDR = 337,
+
+        AV1_480p = 397,
+        AV1_360p = 396,
+        AV1_240p = 395,
+        AV1_144p = 394,
+
+        AV1_HFR_4320p_1 = 571,
+        AV1_HFR_4320p_2 = 402,
+        AV1_HFR_2160p = 401,
+        AV1_HFR_1440p = 400,
+        AV1_HFR_1080p = 399,
+        AV1_HFR_720p = 398,
+
+        AV1_HFR_HIGH_2160p = 701,
+        AV1_HFR_HIGH_1440p = 700,
+        AV1_HFR_HIGH_1080p = 699,
+        AV1_HFR_HIGH_720p = 698,
+
+        // Live video
+        H264_144p_AAC_48 = 91,
+        H264_240p_AAC_48 = 92,
+        H264_360p_AAC_128 = 93,
+        H264_480p_AAC_128 = 94,
+        H264_720p_AAC_256 = 95,
+        H264_1080p_AAC_256 = 96,
+        H264_720p60_AAC_128 = 300,
+        H264_1080p60_AAC_128 = 301,
+
+        // Audio
+        Opus_160 = 251,
+        AAC_128 = 140,
+
+        // Video + Audio
+        H264_360P_AAC_128 = 18,
+        H264_720P_AAC_128 = 22,
+    };
 
     enum
     {
-        _4320p60,
-        _2160p60,
-        _1440p60,
-        _1080p60,
-        _720p60,
-        _2160p,
-        _1440p,
-        _1080p,
-        _720p,
-        _480p,
-        QualityPresetsCount,
+        Preset_4320p60,
+        Preset_2160p60,
+        Preset_1440p60,
+        Preset_1080p60,
+        Preset_720p60,
+        Preset_2160p,
+        Preset_1440p,
+        Preset_1080p,
+        Preset_720p,
+        Preset_480p,
+
+        PresetCount,
     };
 
-    QList<int> qualityPresets[QualityPresetsCount];
+    QVector<int> qualityPresets[PresetCount];
     {
-        qualityPresets[_720p60]  << 298 << 302;
-        qualityPresets[_1080p60] << 299 << 303 << qualityPresets[_720p60];
-        qualityPresets[_1440p60] << 308 << qualityPresets[_1080p60];
-        qualityPresets[_2160p60] << 315 << qualityPresets[_1440p60];
-        qualityPresets[_4320p60] << 272 << qualityPresets[_2160p60];
-
-        qualityPresets[_480p]  << 135 << 134 << 133;
-        qualityPresets[_720p]  << 136 << 247 << qualityPresets[_480p];
-        qualityPresets[_1080p] << 137 << 248 << qualityPresets[_720p];
-        qualityPresets[_1440p] << 264 << 271 << qualityPresets[_1080p];
-        qualityPresets[_2160p] << 266 << 313 << qualityPresets[_1440p];
+        auto maybeAppendVp9Hdr = [this, &qualityPresets] {
+            if (m_allowVp9Hdr)
+            {
+                qualityPresets[Preset_720p60]  << VP9_720p60_HDR;
+                qualityPresets[Preset_1080p60] << VP9_1080p60_HDR;
+                qualityPresets[Preset_1440p60] << VP9_1440p60_HDR;
+                qualityPresets[Preset_2160p60] << VP9_2160p60_HDR;
+            }
+        };
+        if (m_preferredCodec == PreferredCodec::VP9)
+        {
+            qualityPresets[Preset_480p]  << VP9_480p << H264_480p << VP9_360p << H264_360p << H264_360P_AAC_128 << VP9_240p << H264_240p << VP9_144p << H264_144p;
+            qualityPresets[Preset_720p]  << VP9_720p << H264_720p << H264_720P_AAC_128 << qualityPresets[Preset_480p];
+            qualityPresets[Preset_1080p] << VP9_1080p << H264_1080p << qualityPresets[Preset_720p];
+            qualityPresets[Preset_1440p] << VP9_1440p << H264_1440p << qualityPresets[Preset_1080p];
+            qualityPresets[Preset_2160p] << VP9_2160p << H264_2160p << qualityPresets[Preset_1440p];
+
+            maybeAppendVp9Hdr();
+            qualityPresets[Preset_720p60]  << VP9_720p60 << H264_720p60;
+            qualityPresets[Preset_1080p60] << VP9_1080p60 << H264_1080p60 << qualityPresets[Preset_720p60];
+            qualityPresets[Preset_1440p60] << VP9_1440p60 << H264_1440p60 << qualityPresets[Preset_1080p60];
+            qualityPresets[Preset_2160p60] << VP9_2160p60 << H264_2160p60 << qualityPresets[Preset_1440p60];
+            qualityPresets[Preset_4320p60] << VP9_4320p60 << qualityPresets[Preset_2160p60];
+        }
+        else if (m_preferredCodec == PreferredCodec::H264)
+        {
+            qualityPresets[Preset_480p]  << H264_480p << VP9_480p << H264_360p << VP9_360p << H264_360P_AAC_128 << H264_240p << VP9_240p << H264_144p << VP9_144p;
+            qualityPresets[Preset_720p]  << H264_720p << VP9_720p << H264_720P_AAC_128 << qualityPresets[Preset_480p];
+            qualityPresets[Preset_1080p] << H264_1080p << VP9_1080p << qualityPresets[Preset_720p];
+            qualityPresets[Preset_1440p] << H264_1440p << VP9_1440p << qualityPresets[Preset_1080p];
+            qualityPresets[Preset_2160p] << H264_2160p << VP9_2160p << qualityPresets[Preset_1440p];
+
+            qualityPresets[Preset_720p60]  << H264_720p60 << VP9_720p60;
+            qualityPresets[Preset_1080p60] << H264_1080p60 << VP9_1080p60 << qualityPresets[Preset_720p60];
+            qualityPresets[Preset_1440p60] << H264_1440p60 << VP9_1440p60 << qualityPresets[Preset_1080p60];
+            qualityPresets[Preset_2160p60] << H264_2160p60 << VP9_2160p60 << qualityPresets[Preset_1440p60];
+            qualityPresets[Preset_4320p60] << VP9_4320p60 << qualityPresets[Preset_2160p60];
+        }
+        else if (m_preferredCodec == PreferredCodec::AV1)
+        {
+            qualityPresets[Preset_480p]  << AV1_480p << AV1_360p << VP9_480p << H264_480p << VP9_360p << H264_360p << H264_360P_AAC_128 << AV1_240p << VP9_240p << H264_240p << AV1_144p << VP9_144p << H264_144p;
+            qualityPresets[Preset_720p]  << VP9_720p << H264_720p << H264_720P_AAC_128 << qualityPresets[Preset_480p];
+            qualityPresets[Preset_1080p] << VP9_1080p << H264_1080p << qualityPresets[Preset_720p];
+            qualityPresets[Preset_1440p] << VP9_1440p << H264_1440p << qualityPresets[Preset_1080p];
+            qualityPresets[Preset_2160p] << VP9_2160p << H264_2160p << qualityPresets[Preset_1440p];
+
+            qualityPresets[Preset_720p60]  << AV1_HFR_HIGH_720p << AV1_HFR_720p;
+            qualityPresets[Preset_1080p60] << AV1_HFR_HIGH_1080p << AV1_HFR_1080p;
+            qualityPresets[Preset_1440p60] << AV1_HFR_HIGH_1440p << AV1_HFR_1440p;
+            qualityPresets[Preset_2160p60] << AV1_HFR_HIGH_2160p << AV1_HFR_2160p;
+            qualityPresets[Preset_4320p60] << AV1_HFR_4320p_1 << AV1_HFR_4320p_2;
+            maybeAppendVp9Hdr();
+            qualityPresets[Preset_720p60]  << VP9_720p60 << H264_720p60;
+            qualityPresets[Preset_1080p60] << VP9_1080p60 << H264_1080p60 << qualityPresets[Preset_720p60];
+            qualityPresets[Preset_1440p60] << VP9_1440p60 << H264_1440p60 << qualityPresets[Preset_1080p60];
+            qualityPresets[Preset_2160p60] << VP9_2160p60 << H264_2160p60 << qualityPresets[Preset_1440p60];
+            qualityPresets[Preset_4320p60] << VP9_4320p60 << qualityPresets[Preset_2160p60];
+        }
 
         // Append also non-60 FPS itags to 60 FPS itags
-        qualityPresets[_720p60]  += qualityPresets[_720p];
-        qualityPresets[_1080p60] += qualityPresets[_1080p];
-        qualityPresets[_1440p60] += qualityPresets[_1440p];
-        qualityPresets[_2160p60] += qualityPresets[_2160p];
-        qualityPresets[_4320p60] += qualityPresets[_2160p];
+        qualityPresets[Preset_720p60]  << qualityPresets[Preset_720p];
+        qualityPresets[Preset_1080p60] << qualityPresets[Preset_1080p];
+        qualityPresets[Preset_1440p60] << qualityPresets[Preset_1440p];
+        qualityPresets[Preset_2160p60] << qualityPresets[Preset_2160p];
+        qualityPresets[Preset_4320p60] << qualityPresets[Preset_2160p];
     }
 
-    QList<int> liveQualityPresets[QualityPresetsCount];
+    QVector<int> liveQualityPresets[PresetCount];
     {
-        liveQualityPresets[_720p60]  << 300;
-        liveQualityPresets[_1080p60] << 301 << liveQualityPresets[_720p60];
-        liveQualityPresets[_1440p60] << liveQualityPresets[_1080p60];
-        liveQualityPresets[_2160p60] << liveQualityPresets[_1440p60];
-        liveQualityPresets[_4320p60] << liveQualityPresets[_2160p60];
-
-        liveQualityPresets[_480p]  << 94 << 93 << 92 << 91;
-        liveQualityPresets[_720p]  << 95 << liveQualityPresets[_480p];
-        liveQualityPresets[_1080p] << 96 << liveQualityPresets[_720p];
-        liveQualityPresets[_1440p] << 265 << liveQualityPresets[_1080p];
-        liveQualityPresets[_2160p] << 267 << liveQualityPresets[_1440p];
+        liveQualityPresets[Preset_480p]  << H264_480p_AAC_128 << H264_360p_AAC_128 << H264_240p_AAC_48 << H264_144p_AAC_48;
+        liveQualityPresets[Preset_720p]  << H264_720p_AAC_256 << liveQualityPresets[Preset_480p];
+        liveQualityPresets[Preset_1080p] << H264_1080p_AAC_256 << liveQualityPresets[Preset_720p];
+        liveQualityPresets[Preset_1440p] << liveQualityPresets[Preset_1080p];
+        liveQualityPresets[Preset_2160p] << liveQualityPresets[Preset_1440p];
+
+        liveQualityPresets[Preset_720p60]  << H264_720p60_AAC_128;
+        liveQualityPresets[Preset_1080p60] << H264_1080p60_AAC_128 << liveQualityPresets[Preset_720p60];
+        liveQualityPresets[Preset_1440p60] << liveQualityPresets[Preset_1080p60];
+        liveQualityPresets[Preset_2160p60] << liveQualityPresets[Preset_1440p60];
+        liveQualityPresets[Preset_4320p60] << liveQualityPresets[Preset_2160p60];
 
         // Append also non-60 FPS itags to 60 FPS itags
-        liveQualityPresets[_720p60]  += liveQualityPresets[_720p];
-        liveQualityPresets[_1080p60] += liveQualityPresets[_1080p];
-        liveQualityPresets[_1440p60] += liveQualityPresets[_1440p];
-        liveQualityPresets[_2160p60] += liveQualityPresets[_2160p];
-        liveQualityPresets[_4320p60] += liveQualityPresets[_2160p];
+        liveQualityPresets[Preset_720p60]  += liveQualityPresets[Preset_720p];
+        liveQualityPresets[Preset_1080p60] += liveQualityPresets[Preset_1080p];
+        liveQualityPresets[Preset_1440p60] += liveQualityPresets[Preset_1440p];
+        liveQualityPresets[Preset_2160p60] += liveQualityPresets[Preset_2160p];
+        liveQualityPresets[Preset_4320p60] += liveQualityPresets[Preset_2160p];
     }
 
     QMutexLocker locker(&m_itagsMutex);
     m_videoItags = qualityPresets[qualityIdx];
-    m_audioItags = {251, 171, 140, 250, 249};
+    m_audioItags = {Opus_160, AAC_128};
     m_hlsItags = liveQualityPresets[qualityIdx];
-    m_singleUrlItags = {43, 18};
-    if (qualityIdx != _480p)
-        m_singleUrlItags.prepend(22);
 }
 
 void YouTube::deleteReplies()
@@ -725,13 +851,13 @@ void YouTube::setAutocomplete(const QByteArray &data)
     const QJsonDocument json = QJsonDocument::fromJson(data, &jsonErr);
     if (jsonErr.error != QJsonParseError::NoError)
     {
-        qCWarning(youtube) << "Cannot parse autocomplete JSON:" << jsonErr.errorString();
+        qWarning() << "Cannot parse autocomplete JSON:" << jsonErr.errorString();
         return;
     }
     const QJsonArray mainArr = json.array();
     if (mainArr.count() < 2)
     {
-        qCWarning(youtube) << "Invalid autocomplete JSON array";
+        qWarning() << "Invalid autocomplete JSON array";
         return;
     }
     const QJsonArray arr = mainArr.at(1).toArray();
@@ -745,143 +871,108 @@ void YouTube::setAutocomplete(const QByteArray &data)
     if (searchE->hasFocus())
         completer->complete();
 }
-void YouTube::setSearchResults(QString data)
+
+void YouTube::setSearchResults(const QByteArray &data)
 {
-    /* Usuwanie komentarzy HTML */
-    for (int commentIdx = 0 ;;)
-    {
-        if ((commentIdx = data.indexOf("<!--", commentIdx)) < 0)
-            break;
-        int commentEndIdx = data.indexOf("-->", commentIdx);
-        if (commentEndIdx >= 0) //Jeżeli jest koniec komentarza
-            data.remove(commentIdx, commentEndIdx - commentIdx + 3); //Wyrzuć zakomentowany fragment
-        else
-        {
-            data.remove(commentIdx, data.length() - commentIdx); //Wyrzuć cały tekst do końca
-            break;
-        }
-    }
+    const auto json = getYtInitialData(data);
 
-    int i;
-    const QStringList splitted = data.split("yt-lockup ");
-    for (i = 1; i < splitted.count(); ++i)
+    const auto sectionListRendererContents = json.object()
+        ["contents"].toObject()
+        ["twoColumnSearchResultsRenderer"].toObject()
+        ["primaryContents"].toObject()
+        ["sectionListRenderer"].toObject()
+        ["contents"].toArray()
+    ;
+
+    for (auto &&obj : sectionListRendererContents)
     {
-        QString title, videoInfoLink, duration, image, user;
-        const QString &entry = splitted[i];
-        int idx;
+        const auto contents = obj.toObject()
+            ["itemSectionRenderer"].toObject()
+            ["contents"].toArray()
+        ;
 
-        if (entry.contains("yt-lockup-channel")) //Ignore channels
-            continue;
+        for (auto &&obj : contents)
+        {
+            const auto videoRenderer = obj.toObject()["videoRenderer"].toObject();
+            const auto playlistRenderer = obj.toObject()["playlistRenderer"].toObject();
 
-        const bool isPlaylist = entry.contains("yt-lockup-playlist");
+            const bool isVideo = !videoRenderer.isEmpty() && playlistRenderer.isEmpty();
 
-        if ((idx = entry.indexOf("yt-lockup-title")) > -1)
-        {
-            int urlIdx = entry.indexOf("href=\"", idx);
-            int titleIdx = entry.indexOf("title=\"", idx);
-            if (titleIdx > -1 && urlIdx > -1 && titleIdx > urlIdx)
+            QString title, contentId, length, user, publishTime, viewCount, thumbnail, url;
+
+            if (isVideo)
             {
-                const int endUrlIdx = entry.indexOf("\"", urlIdx += 6);
-                const int endTitleIdx = entry.indexOf("\"", titleIdx += 7);
-                if (endTitleIdx > -1 && endUrlIdx > -1 && endTitleIdx > endUrlIdx)
-                {
-                    videoInfoLink = entry.mid(urlIdx, endUrlIdx - urlIdx).replace("&amp;", "&");
-                    if (!videoInfoLink.isEmpty() && videoInfoLink.startsWith('/'))
-                        videoInfoLink.prepend(YOUTUBE_URL);
-                    title = entry.mid(titleIdx, endTitleIdx - titleIdx);
-                }
+                title = videoRenderer["title"].toObject()["runs"].toArray().at(0).toObject()["text"].toString();
+                contentId = videoRenderer["videoId"].toString();
+                if (title.isEmpty() || contentId.isEmpty())
+                    continue;
+
+                length = videoRenderer["lengthText"].toObject()["simpleText"].toString();
+                user = videoRenderer["ownerText"].toObject()["runs"].toArray().at(0).toObject()["text"].toString();
+                publishTime = videoRenderer["publishedTimeText"].toObject()["simpleText"].toString();
+                viewCount = videoRenderer["shortViewCountText"].toObject()["simpleText"].toString();
+                thumbnail = videoRenderer["thumbnail"].toObject()["thumbnails"].toArray().at(0).toObject()["url"].toString();
+
+                url = YOUTUBE_URL "/watch?v=" + contentId;
             }
-        }
-        if ((idx = entry.indexOf("video-thumb")) > -1)
-        {
-            int skip = 0;
-            int imgIdx = entry.indexOf("data-thumb=\"", idx);
-            if (imgIdx > -1)
-                skip = 12;
             else
             {
-                imgIdx = entry.indexOf("src=\"", idx);
-                skip = 5;
-            }
-            if (imgIdx > -1)
-            {
-                int imgEndIdx = entry.indexOf("\"", imgIdx += skip);
-                if (imgEndIdx > -1)
-                {
-                    image = entry.mid(imgIdx, imgEndIdx - imgIdx);
-                    if (image.endsWith(".gif")) //GIF nie jest miniaturką - jest to pojedynczy piksel :D (very old code, is it still relevant?)
-                        image.clear();
-                    else if (image.startsWith("//"))
-                        image.prepend("https:");
-                    if ((idx = image.indexOf("?")) > 0)
-                        image.truncate(idx);
-                }
-            }
-        }
-        if (!isPlaylist && (idx = entry.indexOf("video-time")) > -1 && (idx = entry.indexOf(">", idx)) > -1)
-        {
-            int endIdx = entry.indexOf("<", idx += 1);
-            if (endIdx > -1)
-            {
-                duration = entry.mid(idx, endIdx - idx);
-                if (!duration.startsWith("0") && duration.indexOf(":") == 1 && duration.count(":") == 1)
-                    duration.prepend("0");
+                title = playlistRenderer["title"].toObject()["simpleText"].toString();
+                contentId = playlistRenderer["playlistId"].toString();
+                if (title.isEmpty() || contentId.isEmpty())
+                    continue;
+
+                user = playlistRenderer["longBylineText"].toObject()["runs"].toArray().at(0).toObject()["text"].toString();
+                thumbnail = playlistRenderer
+                    ["thumbnailRenderer"].toObject()
+                    ["playlistVideoThumbnailRenderer"].toObject()
+                    ["thumbnail"].toObject()
+                    ["thumbnails"].toArray().at(0).toObject()
+                    ["url"].toString()
+                ;
+
+                url = YOUTUBE_URL "/playlist?list=" + contentId;
             }
-        }
-        if ((idx = entry.indexOf("yt-lockup-byline")) > -1)
-        {
-            int endIdx = entry.indexOf("</a>", idx);
-            if (endIdx > -1 && (idx = entry.lastIndexOf(">", endIdx)) > -1)
-            {
-                ++idx;
 
-                QTextDocument txtDoc;
-                txtDoc.setHtml(entry.mid(idx, endIdx - idx));
-                user = txtDoc.toPlainText();
-            }
-        }
+            auto tWI = new QTreeWidgetItem(resultsW);
 
-        if (!title.isEmpty() && !videoInfoLink.isEmpty())
-        {
-            QTreeWidgetItem *tWI = new QTreeWidgetItem(resultsW);
-
-            QTextDocument txtDoc;
-            txtDoc.setHtml(title);
-
-            tWI->setText(0, txtDoc.toPlainText());
-            tWI->setText(1, !isPlaylist ? duration : tr("Playlist"));
+            tWI->setText(0, title);
+            tWI->setText(1, isVideo ? length : tr("Playlist"));
             tWI->setText(2, user);
 
-            tWI->setToolTip(0, QString("%1: %2\n%3: %4\n%5: %6")
-                .arg(resultsW->headerItem()->text(0), tWI->text(0),
-                !isPlaylist ? resultsW->headerItem()->text(1) : tr("Playlist"),
-                !isPlaylist ? tWI->text(1) : tr("yes"),
-                resultsW->headerItem()->text(2), tWI->text(2))
-            );
+            QString tooltip;
+            tooltip += QString("%1: %2\n").arg(resultsW->headerItem()->text(0), tWI->text(0));
+            tooltip += QString("%1: %2\n").arg(isVideo ? resultsW->headerItem()->text(1) : tr("Playlist"), isVideo ? tWI->text(1) : tr("yes"));
+            tooltip += QString("%1: %2").arg(resultsW->headerItem()->text(2), tWI->text(2));
+            if (isVideo)
+            {
+                tooltip += QString("\n%1: %2\n").arg(tr("Publish time"), publishTime);
+                tooltip += QString("%1: %2").arg(tr("View count"), viewCount);
+            }
+            tWI->setToolTip(0, tooltip);
 
-            tWI->setData(0, Qt::UserRole, videoInfoLink);
-            tWI->setData(1, Qt::UserRole, isPlaylist);
+            tWI->setData(0, Qt::UserRole, url);
+            tWI->setData(1, Qt::UserRole, !isVideo);
 
-            if (isPlaylist)
+            if (!isVideo)
             {
                 tWI->setDisabled(true);
 
-                NetworkReply *linkReply = net.start(videoInfoLink);
-                linkReply->setProperty("tWI", qVariantFromValue((void *)tWI));
+                auto linkReply = net.start(url);
+                linkReply->setProperty("tWI", QVariant::fromValue((void *)tWI));
                 linkReplies += linkReply;
             }
 
-            NetworkReply *imageReply = net.start(image);
-            imageReply->setProperty("tWI", qVariantFromValue((void *)tWI));
-            imageReplies += imageReply;
+            if (!thumbnail.isEmpty())
+            {
+                auto imageReply = net.start(thumbnail);
+                imageReply->setProperty("tWI", QVariant::fromValue((void *)tWI));
+                imageReplies += imageReply;
+            }
         }
     }
 
-    if (i == 1)
-    {
-        resultsW->clear();
-    }
-    else
+    if (resultsW->topLevelItemCount() > 0)
     {
         pageSwitcher->currPageB->setValue(currPage);
         pageSwitcher->show();
@@ -927,7 +1018,6 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
     const auto videoItags = m_videoItags;
     const auto audioItags = m_audioItags;
     const auto hlsItags = m_hlsItags;
-    const auto singleUrlItags = m_singleUrlItags;
     m_itagsMutex.unlock();
 
     QHash<int, QPair<QString, QString>> itagsData;
